import java.awt.*;
import java.math.*;
import java.awt.event.*;
import java.awt.geom.*;
import java.math.*;
import java.util.Arrays;

/**This file computes the folllowing data:  We
   choose a point in the partition X*, which is
   the set of plaid polytopes in the big set Z,
   and then we see where random points go under
   the plaid dynamics.  This helps us compute the
   partition X intersect F_X^{-1}(X).*/


public class GenerateDynamics2 implements Runnable {
    boolean HALT=true;
    int[][] LIST=new int[100][5];
    int COUNT=0;

    public void run() {
	int choice=1;  
	HALT=false;
	while(HALT==false) {
	    Vector4 V=randomZ();
	    int z=inPlaidZone(V);
	    V=PlaidClassifyFast.plaidDynamicsRaw(V,choice);
	    int[] a=PlaidClassify.plaidIndexDebug(V);
	    int[] temp={z,a[0],a[1],a[2],a[3]};

	    if(ListHelp.onList(temp,LIST,COUNT)==false) {
		LIST[COUNT]=temp;
		++COUNT;
		printout();
		System.out.println("------"+COUNT+"------");
	    }
	}
    }


    public void printout() {
	System.out.println("----------");
	System.out.print("{");

	for(int choice=0;choice<21;++choice) {

	for(int i=0;i<COUNT;++i) {
	    if(LIST[i][0]==choice) {
	      printout(LIST[i]);
	      if(i<COUNT-1) System.out.print(",");
	    }
	}
	}
	System.out.println("");
    }


    public void printout(int[] k) {
	System.out.print("{");
	for(int i=0;i<5;++i) {
             System.out.print(k[i]);
	     if(i<4) System.out.print(",");
	     else System.out.print("}");
	}
    }


    public Vector4 randomZ() {
	int test=-1;
	Vector4 V=new Vector4();
	while(test==-1) {
	  double x=6*Math.random()-3;
	  double y=4*Math.random()-2;
	  double z=2*Math.random()-1;
	  double P=Math.random();
	  V=new Vector4(x,y,z,P);
	  test=inPlaidZone(V);
	}
	return V;
    }

    public int inPlaidZone(Vector4 V) {
	int index=AllPolytopes.indexZ1(V);
	return index;
    }


}





