import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;

public class ScaleConsole {
    Manager M;
    int X;
    int Y;
    SelectInteger S;
    ListenSquare RESCALE,INFO;
    Lever AUTO;

    public ScaleConsole(int x,int y) {
	X=x;
	Y=y;
	S=new SelectInteger(418+X,130+Y,50,24,0,0,200,1);
	RESCALE=new ListenSquare(418+X,100+Y,40,20);
	INFO=new ListenSquare(512+X,148+Y,12,12);
	AUTO=new Lever(469+X,100+Y,0,5);
    }

    public void render(Graphics2D g) {
	g.setColor(new Color(100,0,200));
	g.fillRect((int)(RESCALE.x),(int)(RESCALE.y),106,60);
	g.setColor(Color.white);
	g.drawRect((int)(RESCALE.x),(int)(RESCALE.y),106,60);
        S.render(g,Color.red,Color.white,Color.white);
        RESCALE.render(g,new Color(0,140,0));
	INFO.infoRender(g);
	AUTO.render2(g,"",new Color(0,140,0)); 
        g.setFont(new Font("Helvetica",Font.PLAIN,13));
	g.drawString("reset",(int)(RESCALE.x+5),(int)(RESCALE.y+15));
	g.drawString("zoom",(int)(RESCALE.x+62),(int)(RESCALE.y+25));
    }

    public void switchBlocks(Point X) {	
	int n1=0;
	int n2=0;
	try{
	    n1=M.P.getBlockNumber();
	    S.modify(X);
	    n2=M.P.getBlockNumber();
	}
	catch(Exception e) {}
	AUTO.process(X);
	if(n1!=n2) {
	    int p=M.p();
	    int q=M.q();
	    int w=p+q;
	    M.P.SOURCE.x=M.P.SOURCE.x+w*(n2-n1);
	    double y=M.P.SOURCE.y;
	    y=(y+2*w*w)%w;
	    if(S.val%2==1) y=y-w;
	    M.P.SOURCE.y=y;
	    if(AUTO.val==0) rescale0();
	    if(AUTO.val!=0) rescale1(AUTO.val);
	}
    }


    public void rescale0() {
	try{
	   int h=M.P.getHeight();
	   int w=M.P.getWidth();
	   Path2D.Double gp=M.P.getFrame();
	   M.P.A=GraphicsHelp.preFit(gp,2,5,w-4,h-15);
	}
	catch(Exception e) {}
    }

    public void rescale1(int k) {
	try{
	   int h=M.P.getHeight();
	   int w=M.P.getWidth();
	   Path2D.Double gp=M.P.getLittleFrame(k);
	   M.P.A=GraphicsHelp.preFit(gp,2,5,w-4,h-15);
	}
	catch(Exception e) {}
    }







    public void process(Point X) {
	AUTO.process(X);
	switchBlocks(X);

	for(int i=0;i<3;++i) {
	    if(AUTO.val==0) {
	      if(M.C.PAR.RANDOM.inside(X)==1) rescale0();
	      if(RESCALE.inside(X)==1) rescale0();
	    }
	    if(RESCALE.inside(X)==1) {
		M.P.SOURCE.x=.5;
		M.P.SOURCE.y=.5;
		S.val=0;
                rescale0();
	    }
	}
    }


}


