import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;


    public class AGLocal {
	GeneralPath gp;
	int[] x=new int[4];
	int[] a=new int[2];
	Complex[] z=new Complex[3];

	public AGLocal() {}


	public int match(AGLocal L) {
	    if((a[0]==L.a[0])&&(a[1]==L.a[1])) return(1);
	    if((a[0]==L.a[1])&&(a[1]==L.a[0])) return(1);
	    return(0);
	}

	public int recognizeType(int i,int j) {

	    if((i==1)&&(j==0)) return(1);
	    if((i==1)&&(j==1)) return(2);
	    if((i==0)&&(j==1)) return(3);
	    if((i==-1)&&(j==1)) return(4);
	    if((i==-1)&&(j==0)) return(5);
	    if((i==-1)&&(j==-1)) return(6);
	    if((i==0)&&(j==-1)) return(7);
	    if((i==1)&&(j==-1)) return(8);

	    return(0);
	}


   public void toType() {
	int[] type0={recognizeType(x[0],x[1]),recognizeType(x[2],x[3])};
	a[0]=(int)(Math.min(type0[0],type0[1]));
	a[1]=(int)(Math.max(type0[0],type0[1]));
    }



    /** routines associated to the return map */

    public static Complex toComplex(AGPoint P,double AA) {
	double d=2*AA*P.m+2*P.n+.00000001;
	return(new Complex(d,P.y));
    }

    public static AGPoint firstReturn(AGPoint P,double AA,int direction) {
	AGPinwheel RM=new AGPinwheel(AA);
        int[] ret=new int[3];
	AGPoint PP=new AGPoint(P);
	if(direction==1) PP.y=-P.y;
	Complex z=toComplex(PP,AA);
	ret=RM.doReturnIntegral(z);
	AGPoint Q=new AGPoint(P.m+ret[0],P.n+ret[1],ret[2]);
	if(direction==1) Q.y=-Q.y;
	return(Q);
    }

    public static AGLocal doLocal(int i,int j,double AA) {
	AGLocal L=new AGLocal();
	AGPoint P1=new AGPoint(i,j,-1);
	AGPoint P2=new AGPoint();
	AGPoint P3=new AGPoint();
	Complex test=toComplex(P1,AA);
        P2=firstReturn(P1,AA,0);
        P3=firstReturn(P1,AA,1);
	L.x[0]=P2.m-P1.m;
	L.x[1]=P2.n-P1.n;
        L.x[2]=P3.m-P1.m;
	L.x[3]=P3.n-P1.n;
	L.z[0]=new Complex(P1.m,P1.n);
	L.z[1]=new Complex(P2.m,P2.n);
	L.z[2]=new Complex(P3.m,P3.n);
        L.gp=new GeneralPath();
	L.gp.moveTo(P1.m,P1.n);
	L.gp.lineTo(P2.m,P2.n);	
	L.gp.moveTo(P1.m,P1.n);	
	L.gp.lineTo(P3.m,P3.n);
	L.gp.closePath();
	return(L);
    }











    }
